var currentGadget = origogadget;

gadget =
{
	init: function()
	{
		this.bindState();

		System.Gadget.settingsUI = "settings.html";
		System.Gadget.Flyout.file = "flyout.html";
		System.Gadget.onSettingsClosed = gadget.onCloseSettings;
		System.Gadget.onUndock = gadget.undock;
		System.Gadget.onDock = gadget.dock;
	
		currentGadget.init();
		currentGadget.load();
		
		gadgetflyout.init();
	},	
	versionCheck: function(manifestUrl)
	{
		try
		{
			req = new ActiveXObject("Microsoft.XMLHTTP");
			req.open("GET", manifestUrl, false);
			req.send();
			
			if (req.status == 200)
			{
				if (req.responseXML != null)
				{
					if (req.responseXML.documentElement.selectSingleNode( "version" ).innerText != System.Gadget.version.toString())
					{
				    	return false;
					}	
					
					return true;
				}
			}
		}
		catch (ex) 
		{
			return true;
		}
	},
	bindState: function()
	{
		if(System.Gadget.docked) 
		{
    		this.dock();
		} 
		else
		{
    		this.undock(); 
		}
	},
	
	refresh: function()
	{
		currentGadget.config.read();
		currentGadget.load();
	},
	
	onCloseSettings: function(event)
	{
		if (event.closeAction == event.Action.commit)
		{
			gadget.refresh();
		}
	},
	
	undock: function()
	{
	    // fired by onUnDock()
   		currentGadget.undocked();
	},
	dock: function()
	{
	    // fired by onDock()
   		currentGadget.docked();
	}
}

gadgetsettings =
{
	init: function()
	{
		System.Gadget.onSettingsClosing = gadgetsettings.save;

		currentGadget.config.read();
		currentGadget.settings.display();
	},
	save: function(event)
	{
		if (event.closeAction == event.Action.commit)
		{
			currentGadget.settings.update();
			currentGadget.config.save();
		}
		else if(event.closeAction == event.Action.cancel)
		{
		}

		event.cancel = false;
	}
}

gadgetflyout =
{
	init: function()
	{
		System.Gadget.Flyout.onShow = gadgetflyout.onShow;
        System.Gadget.Flyout.onHide = gadgetflyout.onHide;
	//	currentGadget.config.read();
	//	currentGadget.load();
	},
	keypress: function()
	{	
		currentGadget.flyout.keypress();
	},
	showFlyout: function()
	{
	    // prevent flickering on multiple showFlyout calls
	    if (System.Gadget.Flyout.show == false)
            System.Gadget.Flyout.show = true;
	},
	onShow : function()
	{		
		currentGadget.flyout.display();
	},
	onHide : function()
	{
	}
}

/**
 * Helper functions
 */

function addContentToFlyout(elementID, content)
{
    try
    {
        if(System.Gadget.Flyout.show)
        {
            var flyoutDiv =  System.Gadget.Flyout.document;
            try
            {
                flyoutDiv.getElementById(elementID).innerHTML = content;
            }
            catch(e)
            {
            }
        }
    }
    catch(e)
    {
        //catch slow flyout - no div object will be available.
    }
}

function getFlyoutElementById(elementID)
{
    try
    {
        if(System.Gadget.Flyout.show)
        {
            var flyoutDiv =  System.Gadget.Flyout.document;
            try
            {
                return flyoutDiv.getElementById(elementID);
            }
            catch(e)
            {
            }
        }
    }
    catch(e)
    {
        //catch slow flyout - no div object will be available.
    }
}